<template>
  <section>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Agregar Evento</span>
        </div>
        <div class="navbar-end">
          <div class="navbar-item">
            <div class="field">
              <b-switch type="is-twitter">Salir al guardar</b-switch>
            </div>
          </div>
        </div>
      </nav>
      <div class="section">
        <form @submit.prevent="validate">
           
          <div class="columns is-multiline">
             <div class="column is-5">
             </div>
             <div class="column is-4">
                  
                    <div class="card-image">
      <!-- Show preview of uploaded image -->
      <img :src="getImage" v-if="getImage" alt="Uploaded Image" style="max-width: 100%; height: auto;" />
      <!-- Upload button -->
        <b-upload accept="image/*" v-model="model.file" @input="changeImage">
             <a class="card-content-m button is-primary">
                          <b-icon icon="upload"></b-icon>
                          <span>Subir Imagen</span>
                        </a>
                      </b-upload>
       
    </div>
                  </div>
            <div class="column is-6">
              <b-field
                label="Titulo*"
                :type="{ 'is-danger': errors.has('title') }"
                :message="errors.first('title')"
              >
                <b-input
                  size="is-medium"
                  v-model="model.title"
                  name="title"
                  data-vv-as="Nombre"
                  v-validate="'required'"
                  placeholder="Requerido"
                />
              </b-field>
            </div>
              <div class="column is-6">
              <b-field
                label="Tipo*"
                :type="{ 'is-danger': errors.has('eventType') }"
                :message="errors.first('eventType')"
              >
               <b-select
                placeholder="Seleccione un tipo"
                 size="is-medium"
                 v-model="model.type"
                expanded>
                <option v-for="item in types" :key="item.id"  :value="item.value">{{item.label}}</option>
            </b-select>
              </b-field>
            </div>
              <div class="column is-6" v-if="model.type === 0">
              <b-field
                label="Fecha Del Evento*"
                :type="{ 'is-danger': errors.has('eventDate') }"
                :message="errors.first('eventDate')"
              >
               <b-datetimepicker
                v-model="model.eventDate"
                rounded
                placeholder="Seleccione una fecha"
                icon="calendar-today"
                :icon-right="selected ? 'close-circle' : ''"
                :locale="'es-US'"
                icon-right-clickable
                :timepicker="{ enableSeconds, hourFormat}"
                horizontal-time-picker>
            </b-datetimepicker>
              </b-field>
            </div>
             <div class="column is-12">
              <b-field
                label="Descripción*"
                :type="{ 'is-danger': errors.has('description') }"
                :message="errors.first('description')"
              >
                 <b-input
                      type="textarea"
                       name="description"
                  data-vv-as="Descripción"
                  v-validate="'required'"
                  placeholder="Requerido"
                      v-model="model.description"
                    ></b-input>
              </b-field>
            </div>
          
          </div>
          <nav class="level">
            <!-- Left side -->
            <div class="level-left">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-light"
                  @click="clean"
                  icon-right="eraser"
                  >Limpiar</b-button
                >
              </p>
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-danger"
                  @click="cancel"
                  icon-right="cancel"
                  >Cancelar</b-button
                >
              </p>
            </div>

            <!-- Right side -->
            <div class="level-right">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-primary"
                  native-type="submit"
                  icon-right="content-save"
                  >Guardar</b-button
                >
              </p>
            </div>
          </nav>
        </form>
      </div>
    </div>
  </section>
</template>
<script lang='ts'>
import EventModel from "@/models/event.model";
import EventService from "@/services/eventservice";
import { Component } from "vue-property-decorator";
import BaseVue from "../../core/BaseVue";
import { EventType } from "@/enums/eventType";



@Component
export default class EventAdd extends BaseVue {
  EventService:EventService = new EventService();
  model: EventModel;
  hourFormat:string = "12";
  enableSeconds:boolean = false;
  selected:Date = new Date();
  eventType:EventType = EventType.News;
  imageResult: any = null;
  constructor() {
    super();
    this.model = new EventModel();
  }
    types:any = [
      {
        label: "Noticia",
        value: EventType.News
      },
       {
        label: "Evento",
        value: EventType.Event
      },
    ]
  get getImage() {
    if (this.imageResult) return this.imageResult;
    return false;
  }

  changeImage() {
    var self = this;
    var reader = new FileReader();
    reader.readAsArrayBuffer(this.model.file);
    this.imageResult = URL.createObjectURL(this.model.file);
    reader.onloadend = function (evt: any) {
      if (evt.target.readyState == FileReader.DONE) {
        var arrayBuffer = evt.target.result,
          array = new Uint8Array(arrayBuffer);
        for (var i = 0; i < array.length; i++) {
          self.model.image.push(array[i]);
        }
      }
    };
  }

  public cancel() {
    this.$router.push(`${this.$router.currentRoute.path.split("/agregar")[0]}`);
  }

  public async validate() {
    try {
      var result = await this.$validator.validateAll();
      if (result) {
        this.model.eventDate = new Date();
        await this.EventService.saveEvent(this.model).then((resp) => {
          this.operationSuccess();
        });
        this.$router.push(
          `${this.$router.currentRoute.path.split("/agregar")[0]}`
        );
        return;
      }
      throw this.$validator.errors.items.map((e) => e.msg);
    } catch (errors) {
      this.operationFailedErrors(errors as Array<string>);
    }
  }
  
  public clean() {
    this.model = new EventModel();
  }
  
}
</script>
  <style>

    .card-image {
      width: 300px;
      border-radius: 8px;
      box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
      overflow: hidden;
    }

    .card-image img {
      width: 100%;
  height: 100%; /* Ensure the image fills the container */
  object-fit: cover; /* Maintain aspect ratio and cover entire container */
  display: block;
    }

     .card-content-m {
    padding: 16px !important;
  display: flex !important;
  flex-direction: column !important;
  align-items: center !important;
  justify-content: center !important; /* Center vertically and horizontally */
  height: 100% !important; /* Ensure the content fills the card height */
  margin-top: 10px;
}
.upload {
  /* You can reset the display property to override Buefy's styles */
  display: flex !important;
  justify-content: center !important; /* Center the button horizontally */
  align-items: center !important; /* Center the button vertically */
}


    .card-content-m button {
      padding: 8px 16px;
      background-color: #007bff;
      color: #fff;
      border: none;
      border-radius: 4px;
      cursor: pointer;
      transition: background-color 0.3s ease;
    }

    .card-content-m button:hover {
      background-color: #0056b3;
    }
  </style>

